#
# spec file for package lttng-tools
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define         majorversion 2.7.0

Name:           lttng-tools
Version:        2.7.1
Release:        1.6
Source:         http://lttng.org/files/%{name}/%{name}-%{version}.tar.bz2
Summary:        Linux Trace Toolkit Next Generation 2.0 userspace tools
License:        GPL-2.0 and LGPL-2.1
Group:          Development/Languages/C and C++
Url:            http://lttng.org/lttng2.0
BuildRequires:  liburcu-devel
BuildRequires:  libuuid-devel
BuildRequires:  libxml2-devel
BuildRequires:  lttng-ust-devel >= %{majorversion}
BuildRequires:  pkgconfig
BuildRequires:  popt-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  %ix86 x86_64
Requires:       babeltrace
Recommends:     lttng-modules-kmp

%description
This package provides the userspace tools for controlling the LTTng subsystem
from userspace.

%package -n %{name}-devel

Summary:        Linux Trace Toolkit Next Generation 2.0 userspace tools
Group:          Development/Languages/C and C++
Requires:       %{name} = %{version}-%{release}

%description -n %{name}-devel
This package provides the userspace tools for controlling the LTTng subsystem
from userspace.

%prep
%setup -q

%build
%configure --docdir=%{_docdir}/%{name}
make

%install
make DESTDIR=%buildroot install
rm -vf %buildroot%{_libdir}/*.la

%clean
rm -rf %buildroot

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%dir %{_libdir}/lttng
%dir %{_libdir}/lttng/libexec
%{_bindir}/lttng
%{_bindir}/lttng-crash
%{_bindir}/lttng-relayd
%{_libdir}/lttng/libexec/lttng-consumerd
%{_bindir}/lttng-sessiond
%{_libdir}/*.so.*
%{_mandir}/man1/lttng.1.gz
%{_mandir}/man1/lttng-crash.1.gz
%{_mandir}/man8/lttng-sessiond.8.gz
%{_mandir}/man8/lttng-relayd.8.gz
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/ChangeLog
%{_docdir}/%{name}/LICENSE
%{_docdir}/%{name}/README.md
%{_docdir}/%{name}/*.txt
%dir %{_prefix}/share/xml/lttng
%{_prefix}/share/xml/lttng/session.xsd

%files -n %{name}-devel
%defattr(-,root,root)
%{_prefix}/include/lttng/*
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/lttng-ctl.pc

%changelog
* Thu Jan 28 2016 tonyj@suse.com
- Update to bugfix release 2.7.1 for SLE12SP2
  Changelog:
    http://git.lttng.org/?p=lttng-tools.git;a=blob_plain;f=ChangeLog;hb=v2.7.1
* Mon Oct  5 2015 tonyj@suse.com
- Upgrade to release version 2.7.0 (FATE#319273)
  http://git.lttng.org/?p=lttng-tools.git;a=blob_plain;f=ChangeLog;hb=v2.7.0
  to view changelog from v2.7.0-rc1 to v2.7.0
* Tue Jul 28 2015 tonyj@suse.com
- Update to version 2.7.0-rc1 (FATE#319273)
  Changelog for differences between 2.4.0 and this point may be found at:
    http://git.lttng.org/?p=lttng-tools.git;a=blob_plain;f=ChangeLog;hb=1808007961cfaa7f915e44424f790e616219a361
* Tue Apr 15 2014 tonyj@suse.com
- Update to version 2.4.1
  Changelog:
  * Fix: don't delete stream from connection recv list
  * Fix: use after free of a relayd stream
  * Fix: don't print stream name in error message
  * Fix: take session list lock when listing tp
  * Fix: add consumer wake up pipe to avoid race
  * Fix: don't spawn relayd if URL is provided
  * Fix: don't ask data pending if session was not started
  * Fix: missing test file in EXTRA dist
  * Fix: allow empty URL for live session creation
  * Fix: missing valid return code when adding an URI to consumer
  * Fix: syntax error in lttng.1
  * Fix: check relayd fd leak in lttng cmdline
  * Fix: remove unused tp in high-throughput test
  * Use autoconf AM_MAINTAINER_MODE.
  * Fix: clang 'constant-out-of-range-compare' warning
  * Fix: Unchecked session pointer when destroying a connection in relayd
- Add dependancy on babeltrace and recommend kmps (bnc#872688)
* Fri Feb 28 2014 tonyj@suse.com
- Update to version 2.4.0. Changelog for changes between 2.3.0 and 2.4.0
  may be found at: http://git.lttng.org/?p=lttng-tools.git;a=blob_plain;f=ChangeLog;hb=refs/heads/stable-2.4
* Mon Feb 10 2014 tonyj@suse.com
- Update to version 2.3.1
* Mon Mar 11 2013 tonyj@suse.com
- Upgrade to version 2.1.1 (FATE#314846)
  Changelog 2.1.1:
  * Fix: update next_net_seq_num after sending header
  * Fix: wrong loop continuation in metadata thread
  * Fix: lttng create session memleaks
  * Fix: remove unused session id map
  * Fix: wrong session id used on relayd lookup
  * Fix: add missing UST abi header for make dist
  * Fix: add missing rcu read side lock/unlock
  Changelog 2.1.0:
  * STABLE VERSION 2.1.0-stable - "Basse Messe"
  * Multiple minor fixes
  * Multiple memory and fd leaks
  * Fix: Off by one in seq num for data pending command
  * Fix: flag metadata stream on quiescent control cmd
  * Fix: prioritize control socket communication in relayd
  * Fix: poll and epoll fd set reallocation
  * Fix: add missing goto pending if data is inflight
  * Fix: remove ua_sess->started assert on stop trace
  * Set classes of traffic in high_throughput_limit
  * Fix: use the poll wait ret value when iterating on fd(s)
  * Fix: force the poll() return value to be nb_fd
  * Fix: Wrong check of node when cleaning up ht
  * Fix: set started flag of ust app after ustctl
  * Fix: memory leak in add relayd socket error path
  * Fix: add packed attribute to filter structure
  * Fix: Add missing health code update for consumer command
  * Add LTTNG_PACKED macro
  * Fix data pending for inflight streaming
  * Map session id of relayd and sessiond in consumer
  * Add the relayd create session command
  * Make the consumer sends a ACK after each command
  * Remove MSG_WAITALL on every recvmsg() socket typ
  * Fix: Add missing relayd ht cleanup and ht destroy
  * Fix: Relayd and sessiond version check
  * Fix: protect consumer_find_channel with rcu locking
  * Fix: don't steal key when adding a metadata stream
  * Consumer hold stream mutex for add stream
  Changelog 2.1.0-rc9:
  * Fix: set the stream ht static in consumer file
  * Update sessiond man page with new env var
  * Update lttng.1 man page
  * Fix: enable-consumer for all domains missing dir
  * Fix: Add missing fct prototypes when disabling UST
  * Fix a typo in lttng-probe-module name
  * Assign values to enum lttcomm_sessiond_command
  * Fix: run health test only if root
  * Clarify empty string/NULL filter errors
  * Fix: add missing padding for UST filter
  Changelog 2.1.0-rc8:
  * Fix: Uninit. variable in lttng view
  * Add already enabled UST event error code
  * lttng.h API update: set filter becomes enable event with filter
  * Change the UST event hash table match function
  * Pass lttng_event struct to the set_filter API call
  * Adding context to an event is no longer possible
  * Add UST overlap tests
  * Add filter sequence number to UST
  * Fix: Typo from a previous patch in an assert()
  * Fix: Warn if session is running with lttng view
  * Fix: Add bash requirement to README for make check
  * Fix: add the notion of domain to lttng.1 man page
  * Enable additional kernel probes
  * Update CodingStyle
  * Use the new functions for default subbuf sizes
  * Add default subbuf sizes getter functions
  * Add max() and min() macro in common
  Changelog 2.1.0-rc7:
  * Fix: Add pointer check when freeing poll events
  * Fix: FD leak on thread error
  * Fix: Wrong fd used by kernel_wait_quiescent
  * Support new lttng-ust error code
  * Fix: Don't set filter if enable event fails
  * Fix: Wrong data port when listing session
  * Fix: Enable event after start command
  * Fix: Teardown of thread_manage_clients on failure of listen/create_poll
  * Add a timeout to UST application socket
  * Fix: Consumerd error socket connect race
  * Fix: Set CLOEXEC flag on every created sockets
  * Remove consumer poll timeout in data thread
  * Fix: RCU hash table seed
  * Fix: Do not install health tests helper libraries
  * Fix: Create default channel on add-context if none
  * Support new liblttng-ust-ctl error code
  * Fix: Add EPIPE error handling on buffer splice
  * Fix: Channel creation error return code was not set
  * Fix: Wrong poll events on UST application socket
  * Fix: Remove dependency to urcu-cds in tools tests
  * Fix: Missing librt dependency in configure check for lttng-ust-ctl
  * Fix: Don't append datetime to default session name
  * Fix: Deny session creation name 'auto'
  * Fix: Add space for stream name CPU number
  * Fix: Add output option to enable-channel command
  Changelog 2.1.0-rc6:
  * Tests: Add filtering tests for uncovered cases
  * Fix: Sync issue when deleting a data stream
  * Rename data_available to data_pending
  * Fix: consumer health state
  * Fix: Add the ACCOUNTING flag to ht creation and set bucket size to 0
  * Fix: Bad return error code handling
  * Fix: Use after free() of the rundir string
  * Fix: Cleanup UST app session on ustctl create session error
  * Fix: add missing pthread_join in sessiond
  * Fix: free running directory string
  * Fix: UST app clean list node usage
  * Add liblttng-ctl destructor to cleanup memory
  * Fix: Cleanup URIs on teardown
  * Fix: relayd memleaks
  * Fix: Memory leaks of allocated URIs
  * Fix: consumer output memory leak on creation
  * Fix: missing addrlen initialization before accept(2)
  * Fix: relayd trace file padding memleak
  * Fix: Remove useless consumer subdir string concatenation
  * Fix: lttng create allocated path memleak
  * Fix: Cppcheck memleakOnRealloc mistake
  * Fix: Synchronization issue for data available command
  * Fix: consumer relayd cleanup on disconnect
  * Fix: Handle the unary bitwise negation operator (~) in the XML printer
  * Fix: Possible memory leaks when creating filter IR root node
  * Fix: Delete stream on write error in consumer
  * Fix: Error handling when sending relayd sockets to consumer
  * Add stream lock comment for nesting
  * Fix: Mutex and RCU lock nesting in consumer
  * Fix: Uninitialized ret code
  * Fix: Remove bad condition and fix overflow issue
  * Fix: consumerd pthread error flow
  * Fix: Set a single return point and mutex unlock
  * Fix: Remove useless NULL and zero assignment
  * Fix: segfault on create session with two URLs
  Changelog 2.1.0-rc5:
  * Fix: Remove network stream ID ABI calls
  * Tests: Add filtering tests
  * Wait for data availability when stopping a session
  * Relayd data available command support
  * Lib lttng-ctl data available command support
  * Consumer daemon data available command support
  * Add data structure for the data available command
  * Change the metadata hash table node
  * Make stream hash tables global to the consumer
  * Move add data stream to the data thread
  * Rename consumer threads and spawn them in daemon
  * Fix: relayd close stream command was not working
  * Fix: Relayd and consumerd socket leaks
  * Fix: Missing -ENODATA handling in the consumer
  * Fix: Empty metadata buffer(s) on HUP|ERR
  * ABI with support for compat 32/64 bits
  * Fix: Stream allocation and insertion consistency
  * Fix: output number of bytes written by relayd
  * Add hash table argument to helper functions
  * Fix: Add missing call rcu and read side lock
  * Tests: Fix LD_PRELOAD library lookup path for health tests
  * Fix: Add arbitrary wait period for kernel streaming test
  * Fix coding style and add/change debug statements
  * Fix: Build out of src tree
  * Tests: Add health check tests to configure
  * Tests: Add health check thread stall test
  * Tests: Add health check thread exit test
  * Tests: Add a health check utility program
  * Add testpoints in lttng-sessiond for each threads
  * New testpoint mechanism to instrument binaries for testing
  * Fix: off-by-one in comm proto between lttng-ctl and sessiond
  * Fix: Metadata stream leak when received in consumer
  * Fix: consumer_allocate_stream error handling
  * Fix: consumer should await for initial streams
  * Fix: Missing rcu read side lock in consumer
  Changelog 2.1.0-rc4:
  * Fix: Change sempahore to pthread conditions
  * Fix: relayd relay_send_version: handle sscanf return code
  * Fix relayd: NULL ptr deref
  * Fix: relayd: possible NULL ptr deref, memory leak, accept fd leak
  * Tests: add print bytecode to filter grammar test
  * Cleanup: assign values to bytecode opcodes
  * Fix: Filter: Fix allocation length error
  * Fix: Filter: add missing ast free
  * Tests: Add high throughput with bandwidth limits test
  * Fix: Returned code when listing kernel channel
  * Tests: Rename helper functions to have consistent names
  * Tests: Cleanup redundant code and use printing helper functions
  * Tests: Add helper functions for printing status and banner
  * Tests: Add a check for color support when printing status
  * Fix: Lib lttng-ctl on error returns lttng code
  * Fix: lttng_set_event_filter() was returning bad error code
  * Fix: printing [no write] on lttng list -uf
  * Fix: Disable event on filter error with lttng
  * Fix: Wrong returned error code on UST enable event
  * Add consumer commands to lttng.1 man page
  * Add lttng_health_check(3) man page
  * Fix: Remove LPOLLNVAL from consumer metadata revents
  * Fix: Mismatch of field name between ust and tools
  * Add the written value when listing fields
  * Fix: Consumer return value check after mmap/splice
  * Don't send the subbuffer padding for streaming
  * Fix: Returned error code in consumer on read buffer
  Changelog 2.1.0-rc3:
  * Fix: Relayd fix ret value when adding a connection
  * Add new thread in consumer for metadata handling
  * Fix: consumer recv command error path
  * Fix filter: fix recent regressions
  * Update lttng-ust-abi.h from upstream lttng-ust
  * Fix: Accept bytecode of length 65536 bytes
  * Fix: Generation of bytecode longer than 32768 bytes fails
  * Fix: Filter bytecode alloc buffer size must be a power of 2
  * Add lttng-ctl SWIG python bindings
  * Add C++ support to API header files
  * Librarify filter in liblttng-ctl and hide symbols
  * Set hidden visibility for calls used in lttng-ctl
  * Notify the user if a filter is already enabled
  * Install lttng-error.h and include it in lttng.h
  * Add lttng-error.h containing every API err. code
  * Fix: missing hostname context
  Changelog 2.1.0-rc2:
  * Fix: put back 2.0 output text for lttng create cmd
  * Fix: remove set subdir call that uses bad ptr
  * Filter: Handle the unary bitwise not operator (~) with an unsupported
  * Fix: missing mutex unlock on register consumer err
  * Remove underscore from ifndef of lttng.h
  * Remove unused define in lttng.h
  * Standardize lttng command line usage text
  * Merge duplicate code in consumer for destroy relayd
  * Merge duplicate code in consumer for add relayd
  * Fix: Possible buffer overflows in strncat() usage
  * Move code out of main.c and fix some issues
  Changelog 2.1.0-rc1:
  * Feature: Network Streaming
  * Add the lttng-relayd binary for network streaming
  * Support user space tracer filtering
  * Multiple fixes
* Fri Jun 29 2012 tonyj@suse.com
- Update to release 2.0.3
* Thu Jun 21 2012 tonyj@suse.com
- Update to release 2.0.2
* Thu Jun 14 2012 ro@suse.de
- changed specfile license entry to GPL-2.0 and LGPL-2.1
* Fri Apr 20 2012 tonyj@suse.com
- Update to release 2.0.1
* Wed Mar 21 2012 tonyj@suse.com
- Update to release 2.0.0
* Wed Mar 14 2012 tonyj@suse.com
- Update to version 2.0.0-rc2
* Mon Feb 27 2012 tonyj@suse.com
- Update to version 2.0.0-rc1
* Wed Jan  4 2012 tonyj@suse.com
- Update to version 2.0.pre16
